package jp.ne.sakura.sabowl.gpsnmeajp.intent_hce;

import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

import jp.ne.sakura.sabowl.gpsnmeajp.intent_hce.LazyNfcFHCELite;

public class MainActivity extends AppCompatActivity{
    private String debugMsgTitle = "NFCF-TEST";
    LazyNfcFHCELite hce;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        Log.d(debugMsgTitle, "Create");

        //HCEサービスを初期化
        hce = new LazyNfcFHCELite(this,"jp.ne.sakura.sabowl.gpsnmeajp.intent_hce","jp.ne.sakura.sabowl.gpsnmeajp.intent_hce.lazyNfcFHCELiteProxySettings");
        if(!hce.isHCESupported(this)){
            finish();
        }

        //HCEコールバックを設定
        hce.registerCallback(new LazyNfcFHCELite.onHCEFAccessCallback()
        {
            @Override
            public byte[] onRead(int service,int address) {
                //ReadWithoutEncryptionを受信したとき
                Log.d(debugMsgTitle, "onRead: "+String.format("%04X",address));
                //(R/Wに送信する内容をreturnする)
                return new byte[]{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
            }

            @Override
            public boolean onWrite(int service,int address, byte[] data) {
                //WriteWithoutEncryptionを受信したとき
                Log.d(debugMsgTitle, "onWrite: "+String.format("%04X",address));

                //R/Wから送られてきたデータを表示
                String debug="";
                for(int i=0;i<data.length;i++)
                {
                    debug += String.format("%02X,",data[i]);
                }
                Log.d(debugMsgTitle,debug);

                //R/Wに送信成功応答を返す
                return true;
            }

            @Override
            public void onDeactivate(int reason) {
                //通信が切断されたとき
                Log.d(debugMsgTitle, "onDeactivate: "+reason);
            }
        });

    }

    @Override
    protected void onResume() {
        super.onResume();
        Log.d(debugMsgTitle,"Resume");
        
        //Activityが表示されている時に有効化する(必須)
        hce.enable();
    }

    @Override
    protected void onPause() {
        super.onPause();
        Log.d(debugMsgTitle,"Pause");

        //Activityが表示されていない時に無効化する(必須)
        hce.disable();
    }
}

